;11 / 0bh
;sensenstahl
;www.sensenstahl.com
;fasm 1.69.31
;listening: aeronexus - aeon intergrade (album)
;____________________________________________________________________________
;yeah yeah, late to the party. the 1st draft was in 13h using single pixels,
;but that was a bit too funky. so back to textmode it is \:D/

;this is a (modified/simplified) version of 2048. i had to replace the
;numbers with colors (obviously). but it is quite simple:

;equ    color        hex
;2      blue         01h
;4      green        02h
;8      cyan         03h
;16     red          04h
;32     magenta      05h
;64     brown        06h
;128    light gray   07h
;256    dark gray    08h
;512    light blue   09h <---- with a good run i get here
;1024   light green  0ah
;2048   light cyan   0bh <---- you wanna get here
;4096   light red    0ch
;8192   pink         0dh
;16384  yellow       0eh
;32768  white        0fh

;there is no game over check. if the playfield has no more empty spaces
;the player only can make a move if possible or hit ESC. if there is space
;a random blue block is set.

;there is also no check if blocks can be moved. if all blocks are e.g. on the
;left side, pressing left again makes a new random block appear. that does
;not happen in the original version. but that would cost more bytes.

;also every new block is blue (2) while the original game
;sometimes introduces a 4. but oh well.
;____________________________________________________________________________

;assuming ax = 0 cx = 255 bx = 0

org 100h
use16

fix equ 80*9+34 ;position of the playfield
wall equ 3eb1h  ;0fdbh; everything around the playfield

start:   push 0b800h ;textmooooooode
frmz:    pop ds
         ;inc ax      ;mov al,01h; 1 = 40*25 16 colors
                      ;no need, bomber by tylisha c. anderson & tenie remmel
                      ;also does it, so -1b
                      ;even freedos like that here (tm)
         int 10h

xor bp,bp ;save bytes global
          ;that does not affect calls

;needed because if you die memory would be identical after restart
;so fill the whole segment
cls:
mov word[ds:bx],wall;0
inc bx
inc bx
jnz cls

;make playfield by erasing wall blocks
mov di,80*4
field1:
mov bl,4*2
field2:
mov byte[ds:di+bx+1+fix],bh;0
dec bx
jnz field2
sub di,80
jnz field1

main:

;check if there is empty space left
;if not so break the setting and wait for keypress

xor bx,bx ;init, assuming no space is left

mov di,80*15
checkz:
cmp word[ds:di],bp;0
jne ok
inc bx ;there is empty space left!
ok:
dec di
dec di
jnz checkz

cmp bx,bp;0   ;no space left?
je waiting ;nope, so wait for key
           ;so player can move stuff if possible
           ;or hit esc when there is no way to do anything


;create + set random block
setrnd:
dec dx       ;rnd enough
             ;if dx gets 0 after mul it now
             ;isn't anymore
             ;first i used cx but that was bound to the
             ;keypresses so that was not that random then
in al,40h    ;rnd enough
mul dx       ;rnd enough
xor ax,dx    ;rnd enough
imul di,ax,2 ;word!
cmp di,80*15 ;480
             ;playfield is at 80*9..80*12
             ;so that saves a lot of time
ja setrnd    ;pos out of bound so get another one

cmp word[ds:di+fix],bp;0  ;empty area at generated pos?
jne setrnd                ;nope so get another one
mov word[ds:di+fix],01dbh ;set new block

waiting: mov ah,01h
         int 16h
         jz waiting            ;if no key pressed do nothing
                               ;and simply update screen

         mov ah,00h            ;key pressed so get the code
         int 16h               ;nouws

         cmp al,27             ;esc
         je nothing            ;bye bye

;bx = 0
;cx = ?

mov bl,4*2 ;save a few b below since only pressing a needs
           ;a different value
xor cx,cx  ;pays off with -1b below

cut4:    cmp al,'a'             ;A       ;move left
         jne cut6

;mov cx,-2
dec cx
dec cx
mov bx,-4*2
search3:
mov dx,80*4
search4:
add bx,10 ;adjust!
call engine
sub bx,10 ;remove adjustment
sub dx,80
jnz search4
;add bx,2
inc bx
inc bx
jnz search3

         jmp main ;ok, done, so set next rnd block

cut6:    cmp al,'d'            ;D      ;move right
         jne cut2

mov cl,2
;mov bl,4*2
search1:
mov dx,80*4
search2:
call engine
sub dx,80
jnz search2
;sub bx,2
dec bx
dec bx
jnz search1

         jmp main ;ok, done, so set next rnd block

cut2:    cmp al,'s'            ;S       ;move down
         jne cut8

mov cl,80
;mov bl,4*2
search5:
mov dx,80*4
search6:
call engine
sub dx,cx;80
jnz search6
;sub bx,2
dec bx
dec bx
jnz search5


         jmp main

cut8:    cmp al,'w'            ;W       ;move up
         jne waiting ;there was no esc/wasd pressed
                     ;so wait for a valid key

mov cx,-80
;mov bl,4*2
search7:
mov dx,-80*4
search8:
add dx,80*5 ;adjust
call engine
sub dx,80*5 ;remove adjust
;add dx,80
sub dx,cx ;-1b
jnz search8
;sub bx,2
dec bx
dec bx
jnz search7

jmp main ;ok, done, so set next rnd block


;moves blocks and also adds them up while doing so
;directions given by initial values above
engine:
mov si,dx  ;y
add si,bx  ;x
add si,fix ;pos of playfield
nop        ;OG sneaky nop is back, y'all
mov di,si  ;for working routine

xor ax,ax
add ax,word[ds:si]  ;check current position
jz nothing          ;no block at pos, so move on

;block found!
movor:
add di,cx;2          ;move
cmp word[ds:di],bp;0 ;is there nothing next to the found block?
je movor             ;there is nothing so move again

mov word[ds:si],bp;0 ;delete current block since it gets moved/drawn
                     ;anyway
                     
mov si,di            ;pos of check
sub si,cx;2          ;pos of actual block
cmp word[ds:di],wall;0fdbh ;will it hit the wall?
je done              ;yes so set block and go to next one

cmp word[ds:di],ax   ;hitting against same block?
jne done             ;no, so set
inc ah               ;yes, so add them/change color
add si,cx;2          ;change color of the block you run into
                     ;not the one that is active/already deleted

done:

mov word[ds:si],ax   ;draw block
nothing:
ret                  ;get back / breaker if ESC
nop                  ;256